## iortcw 1.42d+dfsg1

=== MP/Makefile ===
#
# iowolfmp Makefile
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/ | sed -e 's/^arm.*/arm/')

ARM_VER_CHECK=$(shell uname -m)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifndef BUILD_STANDALONE
  BUILD_STANDALONE =
endif
ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     =
endif
ifndef BUILD_UPDATE_SERVER
  BUILD_UPDATE_SERVER     = 0
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   =
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_RENDERER_REND2
  BUILD_RENDERER_REND2 =
endif
ifndef BUILD_ARCHIVE
  BUILD_ARCHIVE = 0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifeq ($(COMPILE_PLATFORM),cygwin)
  PLATFORM=mingw32
endif

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(PLATFORM),mingw32)
  MINGW=1
endif
ifeq ($(PLATFORM),mingw64)
  MINGW=1
endif

ifeq ($(COMPILE_ARCH),i386)
  COMPILE_ARCH=x86
endif
ifeq ($(COMPILE_ARCH),i86pc)
  COMPILE_ARCH=x86
endif

ifeq ($(COMPILE_ARCH),amd64)
  COMPILE_ARCH=x86_64
endif
ifeq ($(COMPILE_ARCH),x64)
  COMPILE_ARCH=x86_64
endif

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifeq ($(COMPILE_ARCH),axp)
  COMPILE_ARCH=alpha
endif

ifeq ($(COMPILE_ARCH),sparc64)
  COMPILE_ARCH=sparc
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

# For historical compatibility reasons on non-windows
# platform output files use i386 instead of x86
ifeq ($(ARCH),x86)
  ifndef MINGW
    FILE_ARCH=i386
  endif
endif

ifndef FILE_ARCH
FILE_ARCH=$(ARCH)
endif
export FILE_ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=1.42d
endif

ifndef CLIENTBIN
  ifdef MINGW
    CLIENTBIN=ioWolfMP
  else
    CLIENTBIN=iowolfmp
  endif
endif

ifndef SERVERBIN
  ifdef MINGW
    SERVERBIN=ioWolfDED
  else
    SERVERBIN=iowolfded
  endif
endif

ifndef BASEGAME
BASEGAME=main
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/wolf"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=1
endif

ifndef USE_CURL_DLOPEN
  ifdef MINGW
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_OPUS
USE_CODEC_OPUS=1
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_FREETYPE
USE_FREETYPE=1
endif

ifndef USE_INTERNAL_LIBS
USE_INTERNAL_LIBS=1
endif

ifndef USE_INTERNAL_OGG
USE_INTERNAL_OGG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_VORBIS
USE_INTERNAL_VORBIS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_OPUS
USE_INTERNAL_OPUS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=$(USE_INTERNAL_LIBS)
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_ANTIWALLHACK
USE_ANTIWALLHACK=1
endif

ifndef USE_BLOOM
USE_BLOOM=1
endif

ifndef USE_OPENGLES
USE_OPENGLES=0
endif

ifndef RASPBERRY_PI
RASPBERRY_PI=0
endif

ifndef USE_PBMD5
USE_PBMD5=1
endif


#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
R2DIR=$(MOUNT_DIR)/rend2
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.4
OPUSDIR=$(MOUNT_DIR)/opus-1.1
OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.6
ZDIR=$(MOUNT_DIR)/zlib-1.2.8
FTDIR=$(MOUNT_DIR)/freetype-2.5.5
SPLDIR=$(MOUNT_DIR)/splines
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
SDLHDIR=$(MOUNT_DIR)/SDL2
LIBSDIR=$(MOUNT_DIR)/libs

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl2|sed 's/-Dmain=SDL_main//')
    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl2)
  else
    # assume they're in the system default paths (no -I or -L needed)
    CURL_LIBS ?= -lcurl
    OPENAL_LIBS ?= -lopenal
  endif
  # Use sdl2-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl2-config),)
      SDL_CFLAGS ?= $(shell sdl2-config --cflags)
      SDL_LIBS ?= $(shell sdl2-config --libs)
    endif
  endif
endif

# Add git version info
#USE_GIT=
#ifeq ($(wildcard ../.git),../.git)
#  GIT_REV=$(shell git show -s --pretty=format:%h-%ad --date=short)
#  ifneq ($(GIT_REV),)
#    VERSION:=$(VERSION)_GIT_$(GIT_REV)
#    USE_GIT=1
#  endif
#endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
INSTALL=install
MKDIR=mkdir
EXTRA_FILES=
CLIENT_EXTRA_FILES=

ifneq (,$(findstring "$(COMPILE_PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
  TOOLS_CFLAGS += -DARCH_STRING=\"$(COMPILE_ARCH)\"
endif

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))

  BASE_CFLAGS = -Wall -fno-strict-aliasing \
    -pipe -DUSE_ICON -DARCH_STRING=\\\"$(FILE_ARCH)\\\"
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM = -O3 -march=i586
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),sparc64)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),alpha)
    # According to http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=410555
    # -ffast-math will cause the client to die with SIGFPE on Alpha
    OPTIMIZE = $(OPTIMIZEVM)
  endif

  SHLIBEXT=so
  SHLIBCFLAGS=-fPIC -fvisibility=hidden
  SHLIBLDFLAGS=-shared $(LDFLAGS)

  THREAD_LIBS=-lpthread
  LIBS=-ldl -lm

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  endif

  ifeq ($(USE_INTERNAL_LIBS),1)
    ifeq ($(CROSS_COMPILING),1)
      ifeq ($(ARCH),x86)
      SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
                 $(LIBSDIR)/linux32/libSDL2.so
      endif
      ifeq ($(ARCH),x86_64)
      SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
                 $(LIBSDIR)/linux64/libSDL2.so
      endif
    endif
  endif

  ifeq ($(USE_OPENGLES),1)
    ifeq ($(RASPBERRY_PI),1)
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      LDFLAGS += -L/opt/vc/lib
      CLIENT_LIBS = $(SDL_LIBS) -lbcm_host
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM -lbcm_host
      SERVER_LIBS = -lbcm_host
    else
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      CLIENT_LIBS = $(SDL_LIBS)
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM
      SERVER_LIBS =
    endif
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
    CLIENT_LIBS += $(SDL_LIBS)
    RENDERER_LIBS += $(SDL_LIBS) -lGL
    SERVER_LIBS =
  endif

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  ifeq ($(USE_MUMBLE),1)
    CLIENT_LIBS += -lrt
  endif

else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)
  LIBS = -framework Cocoa
  CLIENT_LIBS=
  RENDERER_LIBS=
  OPTIMIZEVM=

  BASE_CFLAGS = -Wall -mmacosx-version-min=10.5 \
    -DMAC_OS_X_VERSION_MIN_REQUIRED=1050

  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -arch ppc -faltivec
    OPTIMIZEVM += -O3
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -arch ppc64 -faltivec
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM += -march=prescott -mfpmath=sse
    # x86 vm will crash without -mstackrealign since MMX instructions will be
    # used no matter what and they corrupt the frame pointer in VM calls
    BASE_CFLAGS += -arch i386 -mstackrealign
  endif
  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM += -arch x86_64 -mfpmath=sse
  endif

  # When compiling on OSX for OSX, we're not cross compiling as far as the
  # Makefile is concerned, as target architecture is specified as a compiler
  # argument
  ifeq ($(COMPILE_PLATFORM),darwin)
    CROSS_COMPILING=0
  endif

  ifeq ($(CROSS_COMPILING),1)
    ifeq ($(ARCH),ppc)
      CC=powerpc-apple-darwin10-gcc
      RANLIB=powerpc-apple-darwin10-ranlib
    else
      ifeq ($(ARCH),x86)
        CC=i686-apple-darwin10-gcc
        RANLIB=i686-apple-darwin10-ranlib
      else
        $(error Architecture $(ARCH) is not supported when cross compiling)
      endif
    endif
  else
    TOOLS_CFLAGS += -DMACOS_X
  endif

  BASE_CFLAGS += -fno-strict-aliasing -DMACOS_X -fno-common -pipe

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      ifneq ($(USE_INTERNAL_LIBS),1)
        CLIENT_CFLAGS += $(OPENAL_CFLAGS)
        CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
      else
        CLIENT_LIBS += -framework OpenAL
      endif
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  BASE_CFLAGS += -D_THREAD_SAFE=1

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
  endif

=== SP/Makefile ===
#
# iowolfsp Makefile
#
# GNU Make required
#

COMPILE_PLATFORM=$(shell uname|sed -e s/_.*//|tr '[:upper:]' '[:lower:]'|sed -e 's/\//_/g')

COMPILE_ARCH=$(shell uname -m | sed -e s/i.86/i386/ | sed -e 's/^arm.*/arm/')

ARM_VER_CHECK=$(shell uname -m)

ifeq ($(COMPILE_PLATFORM),sunos)
  # Solaris uname and GNU uname differ
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif
ifeq ($(COMPILE_PLATFORM),darwin)
  # Apple does some things a little differently...
  COMPILE_ARCH=$(shell uname -p | sed -e s/i.86/i386/)
endif

ifndef BUILD_STANDALONE
  BUILD_STANDALONE =
endif
ifndef BUILD_CLIENT
  BUILD_CLIENT     =
endif
ifndef BUILD_SERVER
  BUILD_SERVER     = 0
endif
ifndef BUILD_GAME_SO
  BUILD_GAME_SO    =
endif
ifndef BUILD_GAME_QVM
  BUILD_GAME_QVM   = 0
endif
ifndef BUILD_BASEGAME
  BUILD_BASEGAME =
endif
ifndef BUILD_RENDERER_REND2
  BUILD_RENDERER_REND2 =
endif
ifndef BUILD_ARCHIVE
  BUILD_ARCHIVE = 0
endif

#############################################################################
#
# If you require a different configuration from the defaults below, create a
# new file named "Makefile.local" in the same directory as this file and define
# your parameters there. This allows you to change configuration without
# causing problems with keeping up to date with the repository.
#
#############################################################################
-include Makefile.local

ifeq ($(COMPILE_PLATFORM),cygwin)
  PLATFORM=mingw32
endif

ifndef PLATFORM
PLATFORM=$(COMPILE_PLATFORM)
endif
export PLATFORM

ifeq ($(PLATFORM),mingw32)
  MINGW=1
endif
ifeq ($(PLATFORM),mingw64)
  MINGW=1
endif

ifeq ($(COMPILE_ARCH),i386)
  COMPILE_ARCH=x86
endif
ifeq ($(COMPILE_ARCH),i86pc)
  COMPILE_ARCH=x86
endif

ifeq ($(COMPILE_ARCH),amd64)
  COMPILE_ARCH=x86_64
endif
ifeq ($(COMPILE_ARCH),x64)
  COMPILE_ARCH=x86_64
endif

ifeq ($(COMPILE_ARCH),powerpc)
  COMPILE_ARCH=ppc
endif
ifeq ($(COMPILE_ARCH),powerpc64)
  COMPILE_ARCH=ppc64
endif

ifeq ($(COMPILE_ARCH),axp)
  COMPILE_ARCH=alpha
endif

ifeq ($(COMPILE_ARCH),sparc64)
  COMPILE_ARCH=sparc
endif

ifndef ARCH
ARCH=$(COMPILE_ARCH)
endif
export ARCH

# For historical compatibility reasons on non-windows
# platform output files use i386 instead of x86
ifeq ($(ARCH),x86)
  ifndef MINGW
    FILE_ARCH=i386
  endif
endif

ifndef FILE_ARCH
FILE_ARCH=$(ARCH)
endif
export FILE_ARCH

ifneq ($(PLATFORM),$(COMPILE_PLATFORM))
  CROSS_COMPILING=1
else
  CROSS_COMPILING=0

  ifneq ($(ARCH),$(COMPILE_ARCH))
    CROSS_COMPILING=1
  endif
endif
export CROSS_COMPILING

ifndef VERSION
VERSION=1.42d
endif

ifndef CLIENTBIN
 ifdef MINGW
    CLIENTBIN=ioWolfSP
  else
    CLIENTBIN=iowolfsp
  endif
endif

ifndef SERVERBIN
  ifdef MINGW
    SERVERBIN=ioWolfSPDED
  else
    SERVERBIN=iowolfspded
  endif
endif

ifndef BASEGAME
BASEGAME=main
endif

ifndef BASEGAME_CFLAGS
BASEGAME_CFLAGS=
endif

ifndef COPYDIR
COPYDIR="/usr/local/games/wolf"
endif

ifndef COPYBINDIR
COPYBINDIR=$(COPYDIR)
endif

ifndef MOUNT_DIR
MOUNT_DIR=code
endif

ifndef BUILD_DIR
BUILD_DIR=build
endif

ifndef TEMPDIR
TEMPDIR=/tmp
endif

ifndef GENERATE_DEPENDENCIES
GENERATE_DEPENDENCIES=1
endif

ifndef USE_OPENAL
USE_OPENAL=1
endif

ifndef USE_OPENAL_DLOPEN
USE_OPENAL_DLOPEN=1
endif

ifndef USE_CURL
USE_CURL=0
endif

ifndef USE_CURL_DLOPEN
  ifdef MINGW
    USE_CURL_DLOPEN=0
  else
    USE_CURL_DLOPEN=1
  endif
endif

ifndef USE_CODEC_VORBIS
USE_CODEC_VORBIS=1
endif

ifndef USE_CODEC_OPUS
USE_CODEC_OPUS=1
endif

ifndef USE_MUMBLE
USE_MUMBLE=1
endif

ifndef USE_VOIP
USE_VOIP=1
endif

ifndef USE_FREETYPE
USE_FREETYPE=1
endif

ifndef USE_INTERNAL_LIBS
USE_INTERNAL_LIBS=1
endif

ifndef USE_INTERNAL_OGG
USE_INTERNAL_OGG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_VORBIS
USE_INTERNAL_VORBIS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_OPUS
USE_INTERNAL_OPUS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_ZLIB
USE_INTERNAL_ZLIB=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_JPEG
USE_INTERNAL_JPEG=$(USE_INTERNAL_LIBS)
endif

ifndef USE_INTERNAL_FREETYPE
USE_INTERNAL_FREETYPE=$(USE_INTERNAL_LIBS)
endif

ifndef USE_LOCAL_HEADERS
USE_LOCAL_HEADERS=$(USE_INTERNAL_LIBS)
endif

ifndef USE_RENDERER_DLOPEN
USE_RENDERER_DLOPEN=1
endif

ifndef DEBUG_CFLAGS
DEBUG_CFLAGS=-g -O0
endif

ifndef USE_BLOOM
USE_BLOOM=1
endif

ifndef USE_OPENGLES
USE_OPENGLES=0
endif

ifndef RASPBERRY_PI
RASPBERRY_PI=0
endif


#############################################################################

BD=$(BUILD_DIR)/debug-$(PLATFORM)-$(ARCH)
BR=$(BUILD_DIR)/release-$(PLATFORM)-$(ARCH)
CDIR=$(MOUNT_DIR)/client
SDIR=$(MOUNT_DIR)/server
RDIR=$(MOUNT_DIR)/renderer
R2DIR=$(MOUNT_DIR)/rend2
CMDIR=$(MOUNT_DIR)/qcommon
SDLDIR=$(MOUNT_DIR)/sdl
ASMDIR=$(MOUNT_DIR)/asm
SYSDIR=$(MOUNT_DIR)/sys
GDIR=$(MOUNT_DIR)/game
CGDIR=$(MOUNT_DIR)/cgame
BLIBDIR=$(MOUNT_DIR)/botlib
NDIR=$(MOUNT_DIR)/null
UIDIR=$(MOUNT_DIR)/ui
JPDIR=$(MOUNT_DIR)/jpeg-8c
OGGDIR=$(MOUNT_DIR)/libogg-1.3.2
VORBISDIR=$(MOUNT_DIR)/libvorbis-1.3.4
OPUSDIR=$(MOUNT_DIR)/opus-1.1
OPUSFILEDIR=$(MOUNT_DIR)/opusfile-0.6
ZDIR=$(MOUNT_DIR)/zlib-1.2.8
FTDIR=$(MOUNT_DIR)/freetype-2.5.5
SPLDIR=$(MOUNT_DIR)/splines
Q3ASMDIR=$(MOUNT_DIR)/tools/asm
LBURGDIR=$(MOUNT_DIR)/tools/lcc/lburg
Q3CPPDIR=$(MOUNT_DIR)/tools/lcc/cpp
Q3LCCETCDIR=$(MOUNT_DIR)/tools/lcc/etc
Q3LCCSRCDIR=$(MOUNT_DIR)/tools/lcc/src
SDLHDIR=$(MOUNT_DIR)/SDL2
LIBSDIR=$(MOUNT_DIR)/libs

bin_path=$(shell which $(1) 2> /dev/null)

# We won't need this if we only build the server
ifneq ($(BUILD_CLIENT),0)
  # set PKG_CONFIG_PATH to influence this, e.g.
  # PKG_CONFIG_PATH=/opt/cross/i386-mingw32msvc/lib/pkgconfig
  ifneq ($(call bin_path, pkg-config),)
    CURL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags libcurl)
    CURL_LIBS ?= $(shell pkg-config --silence-errors --libs libcurl)
    OPENAL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags openal)
    OPENAL_LIBS ?= $(shell pkg-config --silence-errors --libs openal)
    SDL_CFLAGS ?= $(shell pkg-config --silence-errors --cflags sdl2|sed 's/-Dmain=SDL_main//')
    SDL_LIBS ?= $(shell pkg-config --silence-errors --libs sdl2)
  else
    # assume they're in the system default paths (no -I or -L needed)
    CURL_LIBS ?= -lcurl
    OPENAL_LIBS ?= -lopenal
  endif
  # Use sdl2-config if all else fails
  ifeq ($(SDL_CFLAGS),)
    ifneq ($(call bin_path, sdl2-config),)
      SDL_CFLAGS ?= $(shell sdl2-config --cflags)
      SDL_LIBS ?= $(shell sdl2-config --libs)
    endif
  endif
endif

# Add git version info
#USE_GIT=
#ifeq ($(wildcard ../.git),../.git)
#  GIT_REV=$(shell git show -s --pretty=format:%h-%ad --date=short)
#  ifneq ($(GIT_REV),)
#    VERSION:=$(VERSION)_GIT_$(GIT_REV)
#    USE_GIT=1
#  endif
#endif


#############################################################################
# SETUP AND BUILD -- LINUX
#############################################################################

## Defaults
INSTALL=install
MKDIR=mkdir
EXTRA_FILES=
CLIENT_EXTRA_FILES=

ifneq (,$(findstring "$(COMPILE_PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))
  TOOLS_CFLAGS += -DARCH_STRING=\"$(COMPILE_ARCH)\"
endif

ifneq (,$(findstring "$(PLATFORM)", "linux" "gnu_kfreebsd" "kfreebsd-gnu" "gnu"))

  BASE_CFLAGS = -Wall -fno-strict-aliasing \
    -pipe -DUSE_ICON -DARCH_STRING=\\\"$(FILE_ARCH)\\\"
  CLIENT_CFLAGS += $(SDL_CFLAGS)

  OPTIMIZEVM = -O3
  OPTIMIZE = $(OPTIMIZEVM) -ffast-math

  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM = -O3
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM = -O3 -march=i586
    OPTIMIZE = $(OPTIMIZEVM) -ffast-math
  endif
  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -maltivec
  endif
  ifeq ($(ARCH),sparc)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),sparc64)
    OPTIMIZE += -mtune=ultrasparc3 -mv8plus
    OPTIMIZEVM += -mtune=ultrasparc3 -mv8plus
  endif
  ifeq ($(ARCH),alpha)
    # According to http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=410555
    # -ffast-math will cause the client to die with SIGFPE on Alpha
    OPTIMIZE = $(OPTIMIZEVM)
  endif

  SHLIBEXT=so
  SHLIBCFLAGS=-fPIC -fvisibility=hidden
  SHLIBLDFLAGS=-shared $(LDFLAGS)

  THREAD_LIBS=-lpthread
  LIBS=-ldl -lm

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  endif

  ifeq ($(USE_INTERNAL_LIBS),1)
    ifeq ($(CROSS_COMPILING),1)
      ifeq ($(ARCH),x86)
      SDL_LIBS = $(LIBSDIR)/linux32/libSDL2main.a \
                 $(LIBSDIR)/linux32/libSDL2.so
      endif
      ifeq ($(ARCH),x86_64)
      SDL_LIBS = $(LIBSDIR)/linux64/libSDL2main.a \
                 $(LIBSDIR)/linux64/libSDL2.so
      endif
    endif
  endif

  ifeq ($(USE_OPENGLES),1)
    ifeq ($(RASPBERRY_PI),1)
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      LDFLAGS += -L/opt/vc/lib
      CLIENT_LIBS = $(SDL_LIBS) -lbcm_host
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM -lbcm_host
      SERVER_LIBS = -lbcm_host
    else
      BUILD_RENDERER_REND2 = 0
      BASE_CFLAGS += -DUSE_OPENGLES
      CLIENT_LIBS = $(SDL_LIBS)
      RENDERER_LIBS = $(SDL_LIBS) -lEGL -lGLESv1_CM
      SERVER_LIBS =
    endif
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
    CLIENT_LIBS += $(SDL_LIBS)
    RENDERER_LIBS += $(SDL_LIBS) -lGL
    SERVER_LIBS =
  endif

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  ifeq ($(USE_MUMBLE),1)
    CLIENT_LIBS += -lrt
  endif

else # ifeq Linux

#############################################################################
# SETUP AND BUILD -- MAC OS X
#############################################################################

ifeq ($(PLATFORM),darwin)
  LIBS = -framework Cocoa
  CLIENT_LIBS=
  RENDERER_LIBS=
  OPTIMIZEVM=

  BASE_CFLAGS = -Wall -mmacosx-version-min=10.5 \
    -DMAC_OS_X_VERSION_MIN_REQUIRED=1050

  ifeq ($(ARCH),ppc)
    BASE_CFLAGS += -arch ppc -faltivec
    OPTIMIZEVM += -O3
  endif
  ifeq ($(ARCH),ppc64)
    BASE_CFLAGS += -arch ppc64 -faltivec
  endif
  ifeq ($(ARCH),x86)
    OPTIMIZEVM += -march=prescott -mfpmath=sse
    # x86 vm will crash without -mstackrealign since MMX instructions will be
    # used no matter what and they corrupt the frame pointer in VM calls
    BASE_CFLAGS += -arch i386 -mstackrealign
  endif
  ifeq ($(ARCH),x86_64)
    OPTIMIZEVM += -arch x86_64 -mfpmath=sse
  endif

  # When compiling on OSX for OSX, we're not cross compiling as far as the
  # Makefile is concerned, as target architecture is specified as a compiler
  # argument
  ifeq ($(COMPILE_PLATFORM),darwin)
    CROSS_COMPILING=0
  endif

  ifeq ($(CROSS_COMPILING),1)
    ifeq ($(ARCH),ppc)
      CC=powerpc-apple-darwin10-gcc
      RANLIB=powerpc-apple-darwin10-ranlib
    else
      ifeq ($(ARCH),x86)
        CC=i686-apple-darwin10-gcc
        RANLIB=i686-apple-darwin10-ranlib
      else
        $(error Architecture $(ARCH) is not supported when cross compiling)
      endif
    endif
  else
    TOOLS_CFLAGS += -DMACOS_X
  endif

  BASE_CFLAGS += -fno-strict-aliasing -DMACOS_X -fno-common -pipe

  ifeq ($(USE_OPENAL),1)
    ifneq ($(USE_OPENAL_DLOPEN),1)
      ifneq ($(USE_INTERNAL_LIBS),1)
        CLIENT_CFLAGS += $(OPENAL_CFLAGS)
        CLIENT_LIBS += $(THREAD_LIBS) $(OPENAL_LIBS)
      else
        CLIENT_LIBS += -framework OpenAL
      endif
    endif
  endif

  ifeq ($(USE_CURL),1)
    CLIENT_CFLAGS += $(CURL_CFLAGS)
    ifneq ($(USE_CURL_DLOPEN),1)
      CLIENT_LIBS += $(CURL_LIBS)
    endif
  endif

  BASE_CFLAGS += -D_THREAD_SAFE=1

  ifeq ($(USE_LOCAL_HEADERS),1)
    CLIENT_CFLAGS += -I$(SDLHDIR)/include
  else
    CLIENT_CFLAGS += $(SDL_CFLAGS)
  endif

  # We copy sdlmain before ranlib'ing it so that subversion doesn't think
  #  the file has been modified by each build.
  ifeq ($(USE_INTERNAL_LIBS),1)
    LIBSDLMAIN=$(B)/libSDL2main.a

=== debian/changelog ===
iortcw (1.42d+dfsg1-3) unstable; urgency=medium

  * Standards-Version: 3.9.8 (no changes required)
  * d/rules: remove misleading leftover comment
  * Upload to unstable

 -- Simon McVittie <smcv@debian.org>  Sun, 17 Jul 2016 20:25:40 +0100

iortcw (1.42d+dfsg1-2) experimental; urgency=medium

  * apparmor: add a child profile for the "safe mode" popups (tested
    with xmessage and zenity - kdialog will probably need more rules)
  * apparmor: don't try to run dh_apparmor on non-Linux ports
  * apparmor: #include the local snippets created by dh_apparmor
  * Add patch to replace __DATE__ with $SOURCE_DATE_EPOCH if set;
    that variable is set automatically by recent debhelper
  * Add Documentation key to the systemd services
  * Add a patch fixing some spelling mistakes in user-visible messages
    (but not "persistant", which is unfortunately part of the API)
  * Enable full compiler hardening

 -- Simon McVittie <smcv@debian.org>  Mon, 21 Mar 2016 09:39:40 +0000

iortcw (1.42d+dfsg1-1) experimental; urgency=medium

  * New upstream release
    - Please note that this upstream release changes the location of game
      files from ~/.iortcw to ~/.wolf.
    - debian/copyright: update
    - debian/rules: update get-orig-source
  * debian/scripts/rtcw.in: use ~/.wolf even in non-release snapshots that
    would normally use ~/.iortcw, for consistency
  * Add a patch to force the "autoupdate" mechanism to be disabled.
    This was off by default anyway, but if enabled, it would download and
    execute arbitrary code from Activision servers without authentication.
  * Switch Vcs-Git to https (see #810378)
  * Standards-Version: 3.9.7 (no changes needed)
  * Add experimental AppArmor profiles to protect the client and server,
    both in "complain" mode for now

 -- Simon McVittie <smcv@debian.org>  Tue, 08 Mar 2016 08:00:37 +0000

iortcw (1.42b+20151119+dfsg1-1) experimental; urgency=medium

  * New upstream snapshot
    - build-depend on Freetype which is now enabled by default upstream
    - enable the new ARMv7 JIT on armhf, forcibly disable it elsewhere
      (avoiding uname)
    - debian/copyright: update
  * debian/rules: maintainer-get-orig-source: put the tarball in
    ../build-area

 -- Simon McVittie <smcv@debian.org>  Sat, 21 Nov 2015 23:11:58 +0000

iortcw (1.42b+20150930+dfsg1-1) experimental; urgency=low

  * New package for Return to Castle Wolfenstein (Closes: #773742)
    - game-data-packager (>= 40) can package the required non-free data
  * Packaging based on ioquake3
  * Initial Debian changes, similar to ioquake3:
    - exclude non-Free lcc compiler (licensed for non-commercial use only)
    - exclude {MP,SP}/media: licensing unclear, and not needed
      (game-data-packager downloads and repackages an unofficial content patch
      from iortcw at the same time it downloads the official patch)
    - exclude Free third-party libraries too, to simplify license compliance,
      and use system copies of those libraries instead:
      cURL, Freetype, libjpeg, libogg, OpenAL, libopus, SDL2, libvorbis, zlib
    - run in a window by default per Games Team policy
    - disable auto-downloading by default since it is a security risk
    - reinstate checks for executable file overwriting and remove code to
      unpack arbitrary native code from (potentially auto-downloaded)
      game mods, fixing vulnerabilities similar to CVE-2011-3012 but
      breaking some mods as an unfortunate but unavoidable side-effect

 -- Simon McVittie <smcv@debian.org>  Mon, 05 Oct 2015 00:17:58 +0100

=== debian/control ===
Source: iortcw
Section: contrib/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Simon McVittie <smcv@debian.org>
Build-Depends: debhelper (>= 9),
               dh-apparmor [linux-any],
               dh-systemd,
               dpkg-dev (>= 1.16.1),
               libcurl4-gnutls-dev,
               libfreetype6-dev,
               libjpeg-dev,
               libopenal-dev,
               libopus-dev,
               libopusfile-dev,
               libsdl2-dev (>= 2.0.0),
               libspeexdsp-dev,
               libvorbis-dev,
Standards-Version: 3.9.8
Vcs-Git: https://anonscm.debian.org/git/pkg-games/iortcw.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-games/iortcw.git
Homepage: https://github.com/iortcw/iortcw/

Package: rtcw
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 rtcw-common (= ${binary:Version}),
Recommends: x11-utils | zenity | kde-baseapps-bin
Description: game engine for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains the iortcw game engines for the single-player campaign
 and multiplayer, based on ioquake3 and the GPL source releases of RTCW.
 .
 For security reasons, this version has been modified to prevent native
 executable code from being unpacked from game packages (PK3 files).
 Some game modifications will not work as a result of this change.
 .
 Return to Castle Wolfenstein requires non-distributable game data files
 in the rtcw-data package, prepared using the game-data-packager tool.

Package: rtcw-server
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 adduser,
 rtcw-common (= ${binary:Version}),
Description: standalone server for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains the iortcw dedicated server for multiplayer,
 based on ioquake3 and the GPL source releases of RTCW. It also contains
 the init script and systemd unit to start the RTCW server, with support
 for multiple server instances under systemd.
 .
 Return to Castle Wolfenstein requires non-distributable game data files
 from the rtcw-data package, prepared using the game-data-packager tool.

Package: rtcw-common
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 rtcw-data (>= 1.42b+40) | game-data-packager (>= 40),
Description: common files for Return to Castle Wolfenstein
 Return to Castle Wolfenstein is a military- and occult-themed first-person
 shooter game in a Second World War setting, originally released in 2001.
 It is a sequel to Wolfenstein 3D, which is also available for Debian
 (in the wolf4sdl package).
 .
 This package contains files shared by the game and the dedicated server.
 It requires non-distributable game data files from the rtcw-data package,
 which can be prepared using the game-data-packager tool.

Package: rtcw-dbg
Architecture: any
Section: contrib/debug
Priority: extra
Depends:
 rtcw (= ${binary:Version}) | rtcw-server (= ${binary:Version}),
 ${misc:Depends},
Description: debug symbols for the iortcw game engine
 This package contains debug symbols for the iortcw game engine,
 which can be used to analyze crashes in Return to Castle Wolfenstein.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

DEB_MAINT_CFLAGS_APPEND := -fsigned-char
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

include /usr/share/dpkg/default.mk

%:
	dh $@ --parallel --with=systemd

ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
TARGET = release
else
TARGET = debug
endif

options := \
	V=1 \
	USE_CODEC_OPUS=1 \
	USE_CODEC_VORBIS=1 \
	USE_CURL=1 \
	USE_CURL_DLOPEN=0 \
	USE_INTERNAL_LIBS=0 \
	USE_LOCAL_HEADERS=0 \
	USE_OPENAL=1 \
	USE_OPENAL_DLOPEN=0 \
	USE_VOIP=1 \
	BUILD_GAME_QVM=0 \
	$(shell debian/q3arch make ${DEB_HOST_GNU_CPU} ${DEB_HOST_GNU_SYSTEM}) \
	COPYDIR=/usr/lib/rtcw \
	VERSION=$(DEB_VERSION)/$(DEB_VENDOR) \
	CFLAGS='$(filter-out -fPIE -pie,$(CFLAGS)) $(CPPFLAGS)' \
	NOTSHLIBCFLAGS='$(filter -fPIE -pie,$(CFLAGS))' \
	LDFLAGS='$(filter-out -fPIE -pie,$(LDFLAGS))' \
	NOTSHLIBLDFLAGS='$(filter -fPIE -pie,$(LDFLAGS))' \
	$(NULL)
sp_options := \
	BR=$(CURDIR)/debian/build/sp \
	BD=$(CURDIR)/debian/build/sp \
	$(NULL)
mp_options := \
	BR=$(CURDIR)/debian/build/mp \
	BD=$(CURDIR)/debian/build/mp \
	$(NULL)

ifeq ($(DEB_HOST_ARCH),armhf)
options += ARM_VER_CHECK=armv7l
else
options += ARM_VER_CHECK=something_else
endif

override_dh_auto_build:
	install -d debian/build/mp debian/build/sp
	make -C SP -- $(options) $(sp_options) $(TARGET)
	cd debian/build/sp && ln -s iowolfsp.* iowolfsp
	make -C MP -- $(options) $(mp_options) $(TARGET)
	cd debian/build/mp && ln -s iowolfmp.* iowolfmp
	cd debian/build/mp && ln -s iowolfded.* iowolfded
	sed \
		-e 's!@IOQ3BINARY@!iowolfsp!' \
		-e 's!@IOQ3SELF@!wolfsp!' \
		-e 's!@IOQ3ROLE@!single-player!' \
		< debian/scripts/rtcw.in > debian/scripts/wolfsp
	sed \
		-e 's!@IOQ3BINARY@!iowolfmp!' \
		-e 's!@IOQ3SELF@!wolfmp!' \
		-e 's!@IOQ3ROLE@!multiplayer!' \
		< debian/scripts/rtcw.in > debian/scripts/wolfmp
	sed \
		-e 's!@IOQ3BINARY@!iowolfded!' \
		-e 's!@IOQ3SELF@!wolfded!' \
		-e 's!@IOQ3ROLE@!multiplayer server!' \
		< debian/scripts/rtcw.in > debian/scripts/wolfded
	chmod +x debian/scripts/wolfsp
	chmod +x debian/scripts/wolfmp
	chmod +x debian/scripts/wolfded

ifeq ($(DEB_HOST_ARCH_OS),linux)
override_dh_install-arch:
	dh_install -a
	dh_apparmor -prtcw --profile-name=usr.lib.rtcw
	dh_apparmor -prtcw-server --profile-name=usr.lib.rtcw.iowolfded
endif

override_dh_strip:
	dh_strip --dbg-package=rtcw-dbg

override_dh_clean:
	dh_clean -XSP/code/game/g_func_decs.h.orig -XSP/code/game/g_funcs.h.orig

override_dh_auto_clean:
	make -C SP -- $(options) $(sp_options) clean
	make -C MP -- $(options) $(mp_options) clean
	find debian/build || :
	rm -fr debian/build

# ---------------------------------------------------------------------------

# Not done automatically to avoid a build-dependency on inkscape
maintainer-update-icons: \
		debian/32/wolfsp.png \
		debian/48/wolfsp.png \
		debian/32/wolfmp.png \
		debian/48/wolfmp.png \
		$(NULL)
	inkscape -C -w 32 -h 32 --export-png=debian/32/wolfsp.png debian/wolfsp.svg
	inkscape -C -w 48 -h 48 --export-png=debian/48/wolfsp.png debian/wolfsp.svg
	inkscape -C -w 32 -h 32 --export-png=debian/32/wolfmp.png debian/wolfmp.svg
	inkscape -C -w 48 -h 48 --export-png=debian/48/wolfmp.png debian/wolfmp.svg

ORIG_REPO ?= https://github.com/iortcw/iortcw
ORIG_REL = 1.42d
# Empty if packaging a release
ORIG_REV =
# Empty if ORIG_REV is
ORIG_DATE =
ORIG_SUFFIX = +dfsg1

ifeq (${ORIG_REV},)
	ORIG_VER := ${ORIG_REL}${ORIG_SUFFIX}
	ORIG_EXPORT := ${ORIG_REL}
else
	ORIG_VER := ${ORIG_REL}+${ORIG_DATE}${ORIG_SUFFIX}
	ORIG_EXPORT := ${ORIG_REV}
endif

get-orig-source:
	git clone --bare --branch master ${ORIG_REPO} iortcw-${ORIG_VER}.git
	GIT_DIR=iortcw-${ORIG_VER}.git git archive \
		--format=tar \
		--prefix=iortcw-${ORIG_VER}.orig/ \
		${ORIG_EXPORT} | tar -xvf-
	test -e iortcw-${ORIG_VER}.orig/MP/COPYING.txt || wget -O iortcw-${ORIG_VER}.orig/MP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-MP/master/COPYING.txt
	test -e iortcw-${ORIG_VER}.orig/SP/COPYING.txt || wget -O iortcw-${ORIG_VER}.orig/SP/COPYING.txt https://raw.githubusercontent.com/id-Software/RTCW-SP/master/COPYING.txt
	: # if in the Debian checkout, check that they haven't changed
	if [ -e debian/rtcw.install ]; then \
		e=0; \
		diff -u MP/COPYING.txt iortcw-${ORIG_VER}.orig/MP/COPYING.txt || e=$$?; \
		diff -u SP/COPYING.txt iortcw-${ORIG_VER}.orig/SP/COPYING.txt || e=$$?; \
		exit $$e; \
	fi
	rm -rf iortcw-${ORIG_VER}.orig/*/code/AL
	rm -rf iortcw-${ORIG_VER}.orig/*/code/SDL2
	rm -rf iortcw-${ORIG_VER}.orig/*/code/freetype-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/jpeg-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/libcurl-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/libogg-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/libs
	rm -rf iortcw-${ORIG_VER}.orig/*/code/libvorbis-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/opus-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/opusfile-*
	rm -rf iortcw-${ORIG_VER}.orig/*/code/tools/lcc
	# Preserve ioapi.? and unzip.? (minizip) because they've been modified
	# to use the idTech3 memory-pool implementation, to avoid leaks when
	# loading a level is aborted. Delete the rest of zlib
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/adler32.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/crc32.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/crypt.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/gzguts.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/inffast.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/inffixed.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/inflate.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/inftrees.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/zconf.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/zlib.?
	rm -rf iortcw-${ORIG_VER}.orig/*/code/zlib-*/zutil.?
	rm -rf iortcw-${ORIG_VER}.orig/*/media
	tar --xz -cvf iortcw_${ORIG_VER}.orig.tar.xz iortcw-${ORIG_VER}.orig
	rm -rf iortcw-${ORIG_VER}.orig
	rm -rf iortcw-${ORIG_VER}.git

# to be invoked from a git checkout with upstream github as a remote;
# tarball ends up in ../build-area/
maintainer-get-orig-source:
	$(MAKE) -f debian/rules get-orig-source ORIG_REPO=$$(pwd)/.git
	mv -i -v iortcw_${ORIG_VER}.orig.tar.xz ../build-area/

=== debian/watch ===
version=2
opts=filenamemangle=s/.+\/(\d\S*)\.tar\.gz/iortcw-$1\.tar\.gz/,dversionmangle=s/\+[0-9]{8}\+dfsg[0-9]+$// \
  https://github.com/iortcw/iortcw/tags .*/(\d\S*)\.tar\.gz
